function [fig] = showMsh(filename, plane, point, vec1, vec2, tol)

    [Nodes,Elements] = readMshFile(filename);
    
    fig = figure;
    
    hold on
    for i=1:size(Nodes,1)
        if distancePointPlane(Nodes(i,:), plane) < tol
            x = (Nodes(i,:)-point)*vec1';
            y = (Nodes(i,:)-point)*vec2';
            plot(x,y,'k.','MarkerSize',10);
        end
    end
    
    for i=1:size(Elements,1)
        switch Elements(i,1)
            case 1
                %segment
                if distancePointPlane(Nodes(Elements(i,end-1),:), plane) < tol && ...
                   distancePointPlane(Nodes(Elements(i,end),:), plane) < tol
               
                    x1 = (Nodes(Elements(i,end-1),:)-point)*vec1';
                    x2 = (Nodes(Elements(i,end),:)-point)*vec1';
                    y1 = (Nodes(Elements(i,end-1),:)-point)*vec2';
                    y2 = (Nodes(Elements(i,end),:)-point)*vec2';   
                    plot([x1,x2],[y1,y2],'k');
               
                end

            case 2
                %triangle
                for j=1:3
                    index1 = size(Elements,2)-j;
                    if j==3
                        index1 = size(Elements,2);
                    end
                    index2 = size(Elements,2)-j+1;
                    if distancePointPlane(Nodes(Elements(i,index1),:), plane) < tol && ...
                       distancePointPlane(Nodes(Elements(i,index2),:), plane) < tol

                        x1 = (Nodes(Elements(i,index1),:)-point)*vec1';
                        x2 = (Nodes(Elements(i,index2),:)-point)*vec1';
                        y1 = (Nodes(Elements(i,index1),:)-point)*vec2';
                        y2 = (Nodes(Elements(i,index2),:)-point)*vec2';   
                        plot([x1,x2],[y1,y2],'k');

                    end
                end
            case 3
                %quadrangle
                for j=1:4
                    index1 = size(Elements,2)-j;
                    if j==4
                        index1 = size(Elements,2);
                    end
                    index2 = size(Elements,2)-j+1;
                    if distancePointPlane(Nodes(Elements(i,index1),:), plane) < tol && ...
                       distancePointPlane(Nodes(Elements(i,index2),:), plane) < tol

                        x1 = (Nodes(Elements(i,index1),:)-point)*vec1';
                        x2 = (Nodes(Elements(i,index2),:)-point)*vec1';
                        y1 = (Nodes(Elements(i,index1),:)-point)*vec2';
                        y2 = (Nodes(Elements(i,index2),:)-point)*vec2';   
                        plot([x1,x2],[y1,y2],'k');

                    end
                end
            case 5
                %hexahedron
                for j=1:4
                    index1 = size(Elements,2)-j;
                    if j==4
                        index1 = size(Elements,2);
                    end
                    index2 = size(Elements,2)-j+1;
                    if distancePointPlane(Nodes(Elements(i,index1),:), plane) < tol && ...
                       distancePointPlane(Nodes(Elements(i,index2),:), plane) < tol

                        x1 = (Nodes(Elements(i,index1),:)-point)*vec1';
                        x2 = (Nodes(Elements(i,index2),:)-point)*vec1';
                        y1 = (Nodes(Elements(i,index1),:)-point)*vec2';
                        y2 = (Nodes(Elements(i,index2),:)-point)*vec2';   
                        plot([x1,x2],[y1,y2],'k');

                    end
                end 
                for j=1:4
                    index1 = size(Elements,2)-j-4;
                    if j==4
                        index1 = size(Elements,2)-4;
                    end
                    index2 = size(Elements,2)-j-3;
                    if distancePointPlane(Nodes(Elements(i,index1),:), plane) < tol && ...
                       distancePointPlane(Nodes(Elements(i,index2),:), plane) < tol

                        x1 = (Nodes(Elements(i,index1),:)-point)*vec1';
                        x2 = (Nodes(Elements(i,index2),:)-point)*vec1';
                        y1 = (Nodes(Elements(i,index1),:)-point)*vec2';
                        y2 = (Nodes(Elements(i,index2),:)-point)*vec2';   
                        plot([x1,x2],[y1,y2],'k');

                    end
                end  
                for j=1:4
                    index1 = size(Elements,2)-j-4;
                    if j==4
                        index1 = size(Elements,2)-4;
                    end
                    index2 = size(Elements,2)-j;
                    if j==4
                        index2 = size(Elements,2);
                    end
                    if distancePointPlane(Nodes(Elements(i,index1),:), plane) < tol && ...
                       distancePointPlane(Nodes(Elements(i,index2),:), plane) < tol

                        x1 = (Nodes(Elements(i,index1),:)-point)*vec1';
                        x2 = (Nodes(Elements(i,index2),:)-point)*vec1';
                        y1 = (Nodes(Elements(i,index1),:)-point)*vec2';
                        y2 = (Nodes(Elements(i,index2),:)-point)*vec2';   
                        plot([x1,x2],[y1,y2],'k');

                    end
                end              
        end

    end
    axis equal
end