#include "ResultsDecl.hpp"
#include "ResultsDef.hpp"

typedef katoptron::Map::local_ordinal_type local_ordinal_type;
typedef katoptron::Map::global_ordinal_type global_ordinal_type;

#define SCALAR double

template void writeResultsVTK<SCALAR, local_ordinal_type, global_ordinal_type>(
    const katoptron::Problem &,
    Teuchos::RCP<Tpetra::Vector<SCALAR, local_ordinal_type, global_ordinal_type>>,
    Teuchos::RCP<katoptron::Map>,
    Teuchos::RCP<RandomField<SCALAR, Kokkos::DefaultExecutionSpace>>,
    std::string,
    size_t,
    bool,
    bool);

#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 8, Kokkos::OpenMP>>

template void writeResultsVTK<SCALAR, local_ordinal_type, global_ordinal_type>(
    const katoptron::Problem &,
    Teuchos::RCP<Tpetra::Vector<SCALAR, local_ordinal_type, global_ordinal_type>>,
    Teuchos::RCP<katoptron::Map>,
    Teuchos::RCP<RandomField<SCALAR, Kokkos::DefaultExecutionSpace>>,
    std::string,
    size_t,
    bool,
    bool);

#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 16, Kokkos::OpenMP>>

template void writeResultsVTK<SCALAR, local_ordinal_type, global_ordinal_type>(
    const katoptron::Problem &,
    Teuchos::RCP<Tpetra::Vector<SCALAR, local_ordinal_type, global_ordinal_type>>,
    Teuchos::RCP<katoptron::Map>,
    Teuchos::RCP<RandomField<SCALAR, Kokkos::DefaultExecutionSpace>>,
    std::string,
    size_t,
    bool,
    bool);

#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 24, Kokkos::OpenMP>>

template void writeResultsVTK<SCALAR, local_ordinal_type, global_ordinal_type>(
    const katoptron::Problem &,
    Teuchos::RCP<Tpetra::Vector<SCALAR, local_ordinal_type, global_ordinal_type>>,
    Teuchos::RCP<katoptron::Map>,
    Teuchos::RCP<RandomField<SCALAR, Kokkos::DefaultExecutionSpace>>,
    std::string,
    size_t,
    bool,
    bool);

#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 32, Kokkos::OpenMP>>

template void writeResultsVTK<SCALAR, local_ordinal_type, global_ordinal_type>(
    const katoptron::Problem &,
    Teuchos::RCP<Tpetra::Vector<SCALAR, local_ordinal_type, global_ordinal_type>>,
    Teuchos::RCP<katoptron::Map>,
    Teuchos::RCP<RandomField<SCALAR, Kokkos::DefaultExecutionSpace>>,
    std::string,
    size_t,
    bool,
    bool);

#undef SCALAR
