#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Copyright 2020 University of Liège
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.



import numpy as np

def grid(M):

    M = M.astype(int)
    TMP = M.shape

    d = TMP[0]

    m_max = 0
    for i in range(0,d):
        if m_max < M[i]:
            m_max = M[i]

    X = np.zeros((m_max,d))
    W = np.zeros((m_max,d))

    for i in range(0,d):
        x, w = np.polynomial.legendre.leggauss(M[i])
        for j in range(0,M[i]):
            X[j,i] = x[j]
            W[j,i] = w[j]
    return X, W
