/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WGROUP_H
#define WGROUP_H

#include "tbox.h"
#include "wObject.h"
#include <string>
#include <memory>

namespace tbox
{

/**
 * @brief Group handling a set of elements
 * @authors Romain Boman
 */
class TBOX_API Group : public fwk::wSharedObject
{
public:
#ifndef SWIG
    std::shared_ptr<MshData> msh;
#endif
    Tag *tag;

    Group(std::shared_ptr<MshData> _msh, int no);
    Group(std::shared_ptr<MshData> _msh, std::string const &name);
};

} // namespace tbox

#endif //WGROUP_H
