/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// tboxVtk.i: SWIG input file of the tboxVtk python interface

%feature("autodoc","1");

%module(docstring=
"'tboxVtkw' module: Vtk for shared tools
(c) ULg - A&M",
directors="1",
threads="1"
) tboxVtkw
%{

//#if defined(_WIN32) && defined(__GNUC__)
#undef _hypot
#include <cmath>
//#endif

#include <memory>
#include <string>
#include <sstream>
#include <typeinfo>
#include "tboxVtk.h"

#include "fwkw.h"
#include "tboxw.h"
#include "tboxVtkw.h"

%}

%include "fwkw.swg"

// ----------- MODULES UTILISES ------------
%import "tboxw.i"

// ----------- TBOXVTK CLASSES ----------------
%include "tboxVtk.h"

%shared_ptr(tboxVtk::VtkExport)
%include "wVtkExport.h"
