// $Id$

#ifndef WFIELD_H
#define WFIELD_H

#include "waves.h"
#include "wObject.h"
#include <vector>
#include <string>

/**
 * @brief definition of a scalar field
 */

class WAVES_API Field : public wObject
{
public:
    std::string name;
    size_t id; ///< field value is stored at index "id" in nodal vectors

    Field(std::string &_name, size_t _id);
    virtual void write(std::ostream &out) const;
};

/**
 * @brief list of fields
 */

class WAVES_API Fields : public wObject
{
public:
    std::vector<Field *> fields;

    Fields() : wObject() {}
    ~Fields();
    void add(std::string &_name);
    size_t size() const { return fields.size(); }
    virtual void write(std::ostream &out) const;
};

#endif //WFIELD_H
